-- name: [CS] Rex
-- description: Rex, the OTHER Dinosaur from Super Mario World is on the scene!
-- deluxe: true
local globalModName = "Rex";
local E_MODEL_CHARA = smlua_model_util_get_id("rex_geo");
local TEX_REX = get_texture_info("rex_icon")
local VOICETABLE_REX = {
	--[CHAR_SOUND_OKEY_DOKEY] = 'Silent.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'smw_1-up.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'smw_kick.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'smw_stomp_no_damage.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'smw_stomp_koopa_kid.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'smw_jump.ogg', 'smw_jump.ogg', 'smw_jump.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'smw_spin_jump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'smw_cape_rise.ogg', 'smw_cape_rise.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'smw_yoshi_stomp.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'smw_reserve_item_store.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'smw_midway_gate.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'smw_cape_rise.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'smw_yoshi_stomp.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'smw_lemmy_wendy_falls_out_of_pipe.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'smw_spin_jump.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'smw_yoshi_stomp.ogg', 
	[CHAR_SOUND_HRMM] = 'smw_reserve_item_store.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'smw_goal_iris-out.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'smw_bowser_flies_away.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'smw_pipe.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'smw_swimming.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'smw_yoshi_runs_away.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'smw_yoshi_spit.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'smw_yoshi_spit.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'smw_swimming.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'smw_swimming.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'smw_swimming.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'smw_yoshi_spit.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'smw_yoshi_spit.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'smw_yoshi_spit.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'smw_lost_a_life.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'smw_lost_a_life.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'smw_ludwig_morton_roy_beat.ogg' -- Booted out of level
}

local CHARA_CAPMODELS = { -- cap code
	normal = smlua_model_util_get_id("rex_normal_geo"),
	wing = smlua_model_util_get_id("rex_wing_geo"),
	metal = smlua_model_util_get_id("rex_metal_geo"),
}
local CHARA_PALETTE = { -- this is the default palette!
	[PANTS] = "ffffff",
	[SHIRT] = "ffffff",
	[GLOVES] = "ffffff",
	[SHOES] = "C00028",
	[HAIR] = "334FBF",
	[SKIN] = "FFD953",
	[CAP] = "0F52BA"
}

if _G.charSelectExists and SM64COOPDX_VERSION then
	local curVers = _G.charSelect.version_get();
	if not tonumber(curVers) then -- if this cannot be simplified to a number, there's other strings in this
		curVers = string.gsub(curVers, "[%a%s_()!?:,@#-]+", ""); -- removing all letters, spaces, and the chars in the [set]
		
		curVers = curVers:gsub("%.", "X", 1):gsub("%.", ""):gsub("X", "."); -- removes all instances except the first decimal point
	end
	curVers = tonumber(curVers);
	
	local charNum = _G.charSelect.character_add("Rex", {"The OTHER Super Mario World Dinosaur",}, "Mod by Garrulous64 & Model by PeachesCastle", { r = 255, g = 255, b = 255 }, E_MODEL_CHARA, CT_MARIO, get_texture_info("rex_icon"));
	_G.charSelect.character_add_caps(E_MODEL_CHARA, CHARA_CAPMODELS); -- cap code
	_G.charSelect.character_add_voice(E_MODEL_CHARA, VOICETABLE_REX);
	if curVers >= 1.8 then
		_G.charSelect.character_add_palette_preset(E_MODEL_CHARA, CHARA_PALETTE);
	end
	
	hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
		if _G.charSelect.character_get_voice(m) == VOICETABLE_REX then return _G.charSelect.voice.sound(m, sound) end
	end)
	hook_event(HOOK_MARIO_UPDATE, function (m)
		if _G.charSelect.character_get_voice(m) == VOICETABLE_REX then return _G.charSelect.voice.snore(m) end
	end)
else
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end